var noUserGroups = new Array();
var userGroups = new Array();
var acAllLevel = 0;
var acUsersLevel = 0;
var alertChecked = true;
var currentText = "";

function levelOfSelect(select) {
	for (i=0; i<select.length; i++) {
		if (select.options[i].selected == true) {
			text = select.options[i].text;
			if (text == "1: hidden") {
				return 1}
			if (text == "2: view") {
				return 2}
			if (text == "3: edit") {
				return 3}
			if (text == "4: upload") {
				return 4}}}
	return 0
}

function reduceSelectToLevel(select, level) {
	selectLength = select.options.length;
	currentText = "------";
	for (i=0; i<selectLength; i++) {
		if (select.options[i].selected == true) {
			currentText = select.options[i].text }}
	for (i=(selectLength-1); i>=0; i--) {
		select.options[i] = null}
	select.options[0] = new Option("------");
	select.options[0].selected = true;
	j = 1;
	if (level < 1) {
		select.options[j] = new Option("1: hidden");
		if (select.options[j].text == currentText) {
			select.options[j].selected = true}
		j = j + 1}
	if (level < 2) {
		select.options[j] = new Option("2: view");
		if (select.options[j].text == currentText) {
			select.options[j].selected = true}
		j = j + 1}
	if (level < 3) {
		select.options[j] = new Option("3: edit");
		if (select.options[j].text == currentText) {
			select.options[j].selected = true}
		j = j + 1}
	if (level < 4) {
		select.options[j] = new Option("4: upload");
		if (select.options[j].text == currentText) {
			select.options[j].selected = true}
		}
}

function allAccessLevel() {
	select = document.editForm.acAll;
	for (i=0; i<5; i++) {
		if (select[i].selected) {
			return i}}
}

function acAllChange() {
	level = levelOfSelect(document.editForm.acAll);
	for (iNU=0; iNU<noUserGroups.length; iNU++) {
		reduceSelectToLevel(noUserGroups[iNU][0], level)}
	reduceSelectToLevel(document.editForm.acUsers, level);
	acUsersChange()
}

function acUsersChange() {
	level = levelOfSelect(document.editForm.acUsers);
	if (level == 0) {//at minimum, users have same access as vistors
		level = allAccessLevel()}
	for (iU=0; iU<userGroups.length; iU++) {
		reduceSelectToLevel(userGroups[iU][0], level)}
}

function disableAC(disable) {
	document.editForm.acAll.disabled = disable;
	document.editForm.acUsers.disabled = disable;
	for (i=0; i<userGroups.length; i++) {
		userGroups[i][0].disabled = disable}
	for (i=0; i<noUserGroups.length; i++) {
		noUserGroups[i][0].disabled = disable}		
}

function inheritACChange() {
	if (document.editForm.inheritAC.checked) {
		//return everything to parent level
		document.editForm.acAll[acAllLevel].selected = true;
		reduceSelectToLevel(document.editForm.acUsers, 0);
		document.editForm.acUsers[acUsersLevel].selected = true;
		for (k=0; k<noUserGroups.length; k++) {
			select = noUserGroups[k][0];
			level = noUserGroups[k][1];
			reduceSelectToLevel(select, 0);
			select[level].selected = true}
		for (k=0; k<userGroups.length; k++) {
			select = userGroups[k][0];
			level = userGroups[k][1];
			reduceSelectToLevel(select, 0);
			select[level].selected = true}
		acAllChange();
		//disable everything
		disableAC(true)
		}
	else {
		//enable everything
		disableAC(false)}
}

function addUserGroup(select, level) {
	ugLength = userGroups.length;
	userGroups[ugLength] = new Array(select, level)
}

function addNoUserGroup(select, level) {
	nugLength = noUserGroups.length;
	noUserGroups[nugLength] = new Array(select, level)
}

function initializeWithLevels(allLevel, usersLevel) {
	// assign levels of parents
	acAllLevel = allLevel;
	acUsersLevel = usersLevel;
	// change select choices
	acAllChange();
	acUsersChange();
	// disable if inheriting from parent
	disableAC(document.editForm.inheritAC.checked)
}

function initialize() {
	// change select choices
	acAllChange();
	acUsersChange()
}

function inheritAlertChange() {
	if (document.editForm.inheritAlert.checked) {
		document.editForm.alert.checked = alertChecked}
	document.editForm.alert.disabled = document.editForm.inheritAlert.checked
}

function initializeAlert(parentAlert) {
	alertChecked = parentAlert;
	document.editForm.alert.disabled = document.editForm.inheritAlert.checked
}